package com.hzs.system.sys.service.impl;

import java.util.*;

import cn.hutool.core.collection.CollectionUtil;
import com.hzs.common.domain.system.sys.SysMenu;
import com.hzs.common.domain.system.sys.SysUser;
import com.hzs.common.domain.system.sys.vo.RouterVo;
import com.hzs.system.sys.mapper.SysUserMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.hzs.common.core.constant.UserConstants;
import com.hzs.common.core.utils.StringUtils;
import com.hzs.common.security.utils.SecurityUtils;
import com.hzs.system.sys.mapper.SysMenuMapper;
import com.hzs.system.sys.service.ISysMenuService;

/**
 * 菜单 业务层处理
 *
 * @author hzs
 */
@Service
public class SysMenuServiceImpl implements ISysMenuService {

    @Autowired
    private SysMenuMapper sysMenuMapper;
    @Autowired
    private SysUserMapper sysUserMapper;

    /**
     * 查询系统菜单列表
     *
     * @param menu   菜单信息
     * @param userId
     * @return
     */
    @Override
    public List<SysMenu> selectMenuList(SysMenu menu, Long userId) {
        List<SysMenu> menus;
        if (SysUser.isAdmin(userId)) {
            // 超级管理员显示所有菜单信息
            menus = sysMenuMapper.selectMenuList(menu);
        } else {
            menus = sysMenuMapper.selectMenuListByUserId(menu, userId);
        }
        return menus;
    }

    /**
     * @description: 导出查询所有菜单
     * @author: zhang jing
     * @date: 2023/7/27 14:01
     * @param: [menu]
     * @return: java.util.List<com.hzs.common.domain.system.sys.SysMenu>
     **/
    @Override
    public List<SysMenu> queryAllMenuAndColumn(SysMenu menu) {
        return sysMenuMapper.queryAllMenuAndColumn(menu);
    }


    /**
     * 根据用户ID查询按钮权限
     *
     * @param userId 用户ID
     * @return 权限列表
     */
    @Override
    public Set<String> selectButtonPermsByUserId(Long userId) {
        List<String> perms = sysMenuMapper.selectButtonPermsByUserId(userId);
        Set<String> permsSet = new HashSet<>();
        for (String perm : perms) {
            if (StringUtils.isNotEmpty(perm)) {
                permsSet.addAll(Arrays.asList(perm.trim().split(",")));
            }
        }
        return permsSet;
    }

    /**
     * 根据用户ID查询菜单路由
     *
     * @param userId 用户名称
     * @return 菜单列表
     */
    @Override
    public List<SysMenu> selectMenuRoutersByUserId(Long userId) {
        List<SysMenu> menus;
        if (SecurityUtils.isAdmin(userId)) {
            menus = sysMenuMapper.selectMenuRoutersAll();
        } else {
            menus = sysMenuMapper.selectMenuRoutersByUserId(userId);
        }
        return menus;
    }

    @Override
    public List<SysMenu> selectAllMenuList(SysMenu menu, Long userId) {
        List<SysMenu> menus;
        if (SysUser.isAdmin(userId)) {
            // 超级管理员显示所有菜单信息
            menus = sysMenuMapper.selectMenuList(menu);
        } else {
            menus = sysMenuMapper.selectMenuListByUserId(menu, userId);
        }
        return getChildPerms(menus, 1);
    }

    /**
     * 构建前端路由所需要的菜单
     *
     * @param menus 菜单列表
     * @return 路由列表
     */
    @Override
    public List<RouterVo> buildMenus(List<SysMenu> menus) {
        List<RouterVo> routers = new LinkedList<>();
        for (SysMenu menu : menus) {
            RouterVo router = new RouterVo();
            router.setMenuId(menu.getMenuId());
            router.setMenuType(menu.getMenuType());
            router.setMenuName(menu.getMenuName());
            router.setRouteName(menu.getRouteName());

            List<SysMenu> cMenus = menu.getChildren();
            if (!cMenus.isEmpty() && (UserConstants.TYPE_DIR.equals(menu.getMenuType()) || UserConstants.TYPE_MENU.equals(menu.getMenuType()))) {
                router.setChildren(buildMenus(cMenus));
            } else if (isMenuFrame(menu)) {
                List<RouterVo> childrenList = new ArrayList<>();
                RouterVo children = new RouterVo();
                children.setMenuId(menu.getMenuId());
                children.setMenuType(menu.getMenuType());
                children.setMenuName(menu.getMenuName());
                children.setRouteName(menu.getRouteName());
                childrenList.add(children);
                router.setChildren(childrenList);
            }
            routers.add(router);
        }
        return routers;
    }

    /**
     * 构建前端所需要树结构
     *
     * @param menus 菜单列表
     * @return 树结构列表
     */
    @Override
    public List<SysMenu> buildMenuTree(List<SysMenu> menus) {
        List<SysMenu> returnList = new ArrayList<>();
        List<Long> tempList = new ArrayList<>();
        for (SysMenu menu : menus) {
            tempList.add(menu.getMenuId());
        }
        for (SysMenu menu : menus) {
            // 如果是顶级节点, 遍历该父节点的所有子节点
            if (!tempList.contains(menu.getParentId())) {
                recursionFn(menus, menu);
                returnList.add(menu);
            }
        }
        if (returnList.isEmpty()) {
            returnList = menus;
        }
        return returnList;
    }

    /**
     * 根据菜单ID查询信息
     *
     * @param menuId 菜单ID
     * @return 菜单信息
     */
    @Override
    public SysMenu selectMenuById(Long menuId) {
        return sysMenuMapper.selectMenuById(menuId);
    }

    /**
     * 是否存在菜单子节点
     *
     * @param menuId 菜单ID
     * @return 结果
     */
    @Override
    public boolean hasChildByMenuId(Long menuId) {
        return sysMenuMapper.hasChildByMenuId(menuId) > 0;
    }

    /**
     * 新增保存菜单信息
     *
     * @param menu 菜单信息
     * @return 结果
     */
    @Override
    public int insertMenu(SysMenu menu) {
        return sysMenuMapper.insertMenu(menu);
    }

    /**
     * 修改保存菜单信息
     *
     * @param menu 菜单信息
     * @return 结果
     */
    @Override
    public int updateMenu(SysMenu menu) {
        return sysMenuMapper.updateMenu(menu);
    }

    /**
     * 删除菜单管理信息
     *
     * @param menuId 菜单ID
     * @param userId
     * @return
     */
    @Override
    public int deleteMenuById(Long menuId, Long userId) {
        return sysMenuMapper.deleteMenuById(menuId, userId);
    }

    /**
     * 校验菜单名称是否唯一
     *
     * @param menu 菜单信息
     * @return 结果
     */
    @Override
    public String checkMenuNameUnique(SysMenu menu) {
        long menuId = StringUtils.isNull(menu.getMenuId()) ? -1L : menu.getMenuId();
        SysMenu sysMenu = sysMenuMapper.checkMenuNameUnique(menu.getMenuName(), menu.getParentId());
        if (StringUtils.isNotNull(sysMenu) && sysMenu.getMenuId() != menuId) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    @Override
    public String checkMenuPermsUnique(String perms, Long menuId) {
        SysMenu sysMenu = sysMenuMapper.checkMenuPermsUnique(perms);
        if (StringUtils.isNotNull(sysMenu) && !sysMenu.getMenuId().equals(menuId)) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 是否为菜单内部跳转
     *
     * @param menu 菜单信息
     * @return 结果
     */
    public boolean isMenuFrame(SysMenu menu) {
        return menu.getParentId().intValue() == 0 && UserConstants.TYPE_MENU.equals(menu.getMenuType());
    }

    /**
     * 根据父节点的ID获取所有子节点
     *
     * @param list     分类表
     * @param parentId 传入的父节点ID
     * @return String
     */
    public List<SysMenu> getChildPerms(List<SysMenu> list, int parentId) {
        List<SysMenu> returnList = new ArrayList<>();
        for (SysMenu t : list) {
            // 一、根据传入的某个父节点ID,遍历该父节点的所有子节点
            if (t.getParentId() == parentId) {
                recursionFn(list, t);
                returnList.add(t);
            }
        }
        return returnList;
    }

    /**
     * 递归列表
     *
     * @param list
     * @param t
     */
    private void recursionFn(List<SysMenu> list, SysMenu t) {
        // 得到子节点列表
        List<SysMenu> childList = getChildList(list, t);
        t.setChildren(childList);
        for (SysMenu tChild : childList) {
            if (hasChild(list, tChild)) {
                recursionFn(list, tChild);
            }
        }
    }

    /**
     * 得到子节点列表
     */
    private List<SysMenu> getChildList(List<SysMenu> list, SysMenu t) {
        List<SysMenu> tlist = new ArrayList<>();
        for (SysMenu n : list) {
            if (n.getParentId().longValue() == t.getMenuId().longValue()) {
                tlist.add(n);
            }
        }
        return tlist;
    }

    /**
     * 判断是否有子节点
     */
    private boolean hasChild(List<SysMenu> list, SysMenu t) {
        return getChildList(list, t).size() > 0;
    }

    @Override
    public Map<Long, SysMenu> getAllMenuMap() {
        Map<Long, SysMenu> resultMap = new HashMap<>();
        List<SysMenu> menuList = sysMenuMapper.selectMenuTreeAll();
        if (CollectionUtil.isNotEmpty(menuList)) {
            for (SysMenu sysMenu : menuList) {
                resultMap.put(sysMenu.getMenuId(), sysMenu);
            }
        }
        return resultMap;
    }

    @Override
    public List<SysMenu> queryMenuAndColumn(Long roleId) {
        return sysMenuMapper.queryMenuAndColumn(roleId);
    }

}
